"use strict";

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.promise");

require("regenerator-runtime/runtime");

var _enzyme = require("enzyme");

var _react = _interopRequireDefault(require("react"));

var _addons = _interopRequireDefault(require("@storybook/addons"));

var _coreEvents = require("@storybook/core-events");

var _preview = require("../../preview.test");

var _link = _interopRequireDefault(require("./link"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

jest.mock('@storybook/addons');
describe('LinkTo', function () {
  describe('render', function () {
    it('should render a link',
    /*#__PURE__*/
    _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee() {
      var channel, wrapper;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              channel = (0, _preview.mockChannel)();

              _addons["default"].getChannel.mockReturnValue(channel);

              wrapper = (0, _enzyme.shallow)(_react["default"].createElement(_link["default"], {
                kind: "foo",
                story: "bar"
              }));
              _context.next = 5;
              return wrapper.instance().updateHref(wrapper.props());

            case 5:
              wrapper.update();
              expect(wrapper).toMatchSnapshot();

            case 7:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    })));
  });
  describe('events', function () {
    it('should select the kind and story on click', function () {
      var channel = {
        emit: jest.fn(),
        on: jest.fn()
      };

      _addons["default"].getChannel.mockReturnValue(channel);

      var wrapper = (0, _enzyme.shallow)(_react["default"].createElement(_link["default"], {
        kind: "foo",
        story: "bar"
      }));
      wrapper.simulate('click', {
        button: 0,
        preventDefault: function preventDefault() {}
      });
      expect(channel.emit.mock.calls).toContainEqual([_coreEvents.SELECT_STORY, {
        kind: 'foo',
        story: 'bar'
      }]);
    });
  });
});